package org.hotswap.agent.plugin.spring;

import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.beans.factory.support.DefaultListableBeanFactory;
import org.springframework.web.context.ContextLoader;
import org.springframework.web.context.support.XmlWebApplicationContext;

/**
 * @author Jiri Bubnik
 */
public class SpringRefreshCommand {
    public void refreshBeanDefinition(String className) {
        String beanName = "";
        XmlWebApplicationContext xmlWebApplicationContext =
                (XmlWebApplicationContext) ContextLoader.getCurrentWebApplicationContext();
        DefaultListableBeanFactory defaultListableBeanFactory =
                (DefaultListableBeanFactory) xmlWebApplicationContext.getBeanFactory();
        BeanDefinition beanDefinition = defaultListableBeanFactory.getBeanDefinition(beanName);
        beanDefinition.setBeanClassName(className);
        defaultListableBeanFactory.registerBeanDefinition(beanName, beanDefinition);
    }
}
